<template>
  <v-container>
    <v-dialog v-model="dialog" persistent max-width="50%">
      <v-card>
        <v-card-title>
          <span v-text="title" />
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-row v-if="isEdit">
              <v-col cols="12">
                <v-text-field label="GPON ID*" v-model="gpon.id" required readonly />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="4">
                <v-select
                    :disabled="statusProgress"
                    v-model="gpon.sto.witel.regional.id"
                    :items="regionals"
                    item-text="nama"
                    item-value="id"
                    label="Pilih Regional*"
                    @change="doChangeRegional">
                </v-select>
              </v-col>
              <v-col cols="4">
                <v-select
                    :disabled="statusProgress"
                    v-model="gpon.sto.witel.id"
                    :items="witels"
                    item-text="nama"
                    item-value="id"
                    label="Pilih Witel*"
                    @change="doChangeWitel">
                </v-select>
              </v-col>
              <v-col cols="4">
                <v-select
                    :disabled="statusProgress"
                    v-model="gpon.sto.id"
                    :items="stos"
                    item-text="nama"
                    item-value="id"
                    label="Pilih STO*"
                >
                </v-select>
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="6">
                <v-text-field label="Hostname*" v-model="gpon.hostname" :disabled="statusProgress" required />
              </v-col>
              <v-col cols="6">
                <v-text-field label="IP Address*" v-model="gpon.ip_address" :disabled="statusProgress" required />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="3">
                <v-text-field label="VLAN Internet*" type="number" v-model="gpon.vlan_inet" :disabled="statusProgress" required />
              </v-col>
              <v-col cols="3">
                <v-text-field label="VLAN Voice*" v-model="gpon.vlan_voice" :disabled="statusProgress" required />
              </v-col>
              <v-col cols="6">
                <v-select
                    :disabled="statusProgress"
                    v-model="gpon.nms.id"
                    :items="nms"
                    item-text="nama"
                    item-value="id"
                    label="Pilih NMS*">
                </v-select>
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="5">
                <v-checkbox
                    :disabled="statusProgress"
                    v-model="gpon.default_user_nms"
                    label="Default Using NMS User"
                    class="shrink mr-2 mt-0"
                    @change="doChangeDefaultUserNms"
                />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="6">
                <v-text-field label="Username*" v-model="username" :disabled="statusProgress || gpon.default_user_nms" required />
              </v-col>
              <v-col cols="6">
                <v-text-field label="Password*" v-model="password" :disabled="statusProgress || gpon.default_user_nms" required />
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue darken-1" text @click="doSaveOrUpdate" :disabled="statusProgress">Simpan</v-btn>
          <v-btn color="blue darken-1" text @click="doReset" :disabled="statusProgress">Reset</v-btn>
          <v-btn color="blue darken-1" text @click="doClose" :disabled="statusProgress">Close</v-btn>
        </v-card-actions>
      </v-card>
      <DlgMsg ref="dlgMsg" />
      <Loading ref="loading" :dlg-loading="statusProgress" />
    </v-dialog>
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import gponService from '../service/GponService'
import nmsService from '../service/NmsService'
import stoService from '../service/StoService'
import witelService from '../service/WitelService'
import regionalService from '../service/RegionalService'

export default {
  name: "GponForm",
  components: {
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      regionals: [],
      witels: [],
      stos: [],
      nms: [],
      gpon: {
        id: '0',
        hostname: null,
        ip_address: null,
        vlan_inet: null,
        vlan_voice: null,
        nms: {
          id: null
        },
        sto: {
          id: null,
          witel: {
            id: null,
            regional: {
              id: null
            }
          }
        },
        default_user_nms: true,
        username: null,
        password: null,
      },
      username: null,
      password: null,
      title: null,
      dialog: false,
      isEdit: false,
      statusProgress: false,
    }
  },
  methods: {
    doChangeDefaultUserNms() {
      if (this.gpon.default_user_nms) {
        this.username = null
        this.password = null
      }
    },
    doChangeRegional() {
      this.retrieveWitel(this.gpon.sto.witel.regional.id)
    },
    doChangeWitel() {
      this.retrieveSto(this.gpon.sto.witel.id)
    },
    doClose() {
      this.dialog = false
    },
    async doAdd(title, isEdit) {
      this.title = title
      this.dialog = true
      this.isEdit = isEdit
      this.doReset()
      await this.retrieveNms()
      await this.retrieveRegional()
    },
    doEdit(id, title, isEdit) {
      this.title = title
      this.dialog = true
      this.isEdit = isEdit
      this.retrieveGpon(id)
    },
    doReset() {
      if (!this.isEdit)
        this.gpon.id = '0'
      this.gpon.hostname = null
      this.gpon.ip_address = null
      this.gpon.vlan_inet = null
      this.gpon.vlan_voice = null
      this.gpon.nms.id = null
      this.gpon.sto.id = null
      this.gpon.sto.witel.id = null
      this.gpon.sto.witel.regional.id = null
      this.gpon.default_user_nms = true
      this.gpon.username = null
      this.gpon.password = null
      this.username = null
      this.password = null
    },
    async doSaveOrUpdate() {
      if (!this.validation()) {
        return
      }
      let data = this.gpon
      if (!this.gpon.default_user_nms) {
        data.username = this.username
        data.password = this.password
      }

      this.statusProgress = true
      if (!this.isEdit) {
        await this.doSave(data)
      } else {
        await this.doUpdate(data.id, data)
      }
      this.statusProgress = false
    },
    doSave(data) {
      gponService.store(data)
        .then(async res => {
          if (res.data.status === "SUCCESS") {
            await this.$parent.doRefresh()
            this.doReset()
          }
          this.$refs.dlgMsg.doOpenMsg(res.data.message)
        })
        .catch(ex => {
          console.log(ex.response)
          this.$refs.dlgMsg.doOpenMsg('ERROR EXCEPTION')
        })
    },
    doUpdate(id, data) {
      gponService.update(id, data)
        .then(async res => {
          if (res.data.status === "SUCCESS") {
            await this.$parent.doRefresh()
            this.doReset()
          }
          this.dialog = false
          this.$refs.dlgMsg.doOpenMsg(res.data.message)
        })
        .catch(ex => {
          console.log(ex.response)
          this.$refs.dlgMsg.doOpenMsg('ERROR EXCEPTION')
        })
    },
    async retrieveNms() {
      this.statusProgress = true
      await nmsService.getAll()
        .then(res => {
          let nms = res.data.data
          for (let i in nms) {
            let server = {
              id: nms[i].id,
              nama: nms[i].nama + " - " + nms[i].ip_server,
            }
            this.nms.push(server)
          }
        })
      this.statusProgress = false
    },
    async retrieveRegional() {
      this.statusProgress = true
      await regionalService.getAll()
        .then(res => {
          let regionals = res.data.data
          for (let i in regionals) {
            let reg = {
              id: regionals[i].id,
              nama: regionals[i].id + " - " + regionals[i].nama,
            }
            this.regionals.push(reg)
          }
        })
      this.statusProgress = false
    },
    async retrieveWitel(regional) {
      this.statusProgress = true
      await witelService.getRegional(regional)
        .then(res => {
          this.witels = []
          this.stos = []
          let witels = res.data.data
          for (let i in witels) {
            let witel = {
              id: witels[i].id,
              nama: witels[i].id + " - " + witels[i].nama,
            }
            this.witels.push(witel)
          }
        })
      this.statusProgress = false
    },
    async retrieveSto(witel) {
      this.statusProgress = true
      await stoService.getWitel(witel)
        .then(res => {
          this.stos = []
          let stos = res.data.data
          for (let i in stos) {
            let sto = {
              id: stos[i].id,
              nama: stos[i].id + " - " + stos[i].nama,
            }
            this.stos.push(sto)
          }
        })
      this.statusProgress = false
    },
    async retrieveGpon(id) {
      this.statusProgress = true
      await gponService.getId(id)
        .then(async res => {
          let gpon = res.data.data
          this.gpon = gpon
          await this.retrieveNms()
          await this.retrieveRegional()
          await this.retrieveWitel(gpon.sto.witel.regional.id)
          await this.retrieveSto(gpon.sto.witel.id)
          this.doChangeDefaultUserNms()
        }).catch(ex => {
          console.log(ex.response)
          this.$refs.dlgMsg.doOpenMsg('error while edit data')
      })
      this.statusProgress = false
    },
    validation() {
      if (this.gpon.hostname == null || this.gpon.hostname === '') {
        this.$refs.dlgMsg.doOpenMsg("Hostname Harus Diisi")
        return false
      } else if (this.gpon.ip_address == null || this.gpon.ip_address === '') {
        this.$refs.dlgMsg.doOpenMsg("IP Address Harus Diisi")
        return false
      } else if (this.gpon.vlan_inet == null || this.gpon.vlan_inet === '') {
        this.$refs.dlgMsg.doOpenMsg("VLAN Internet Harus Diisi")
        return false
      } else if (this.gpon.vlan_voice == null || this.gpon.vlan_voice === '') {
        this.$refs.dlgMsg.doOpenMsg("VLAN Voice Harus Diisi")
        return false
      } else if (this.gpon.nms.id == null) {
        this.$refs.dlgMsg.doOpenMsg("NMS Harus Dipilih")
        return false
      } else if (this.gpon.sto.id == null ) {
        this.$refs.dlgMsg.doOpenMsg("STO Harus Dipilih")
        return false
      } else if (this.gpon.sto.witel.id == null) {
        this.$refs.dlgMsg.doOpenMsg("Witel Harus Dipilih")
        return false
      } else if (this.gpon.sto.witel.regional.id == null) {
        this.$refs.dlgMsg.doOpenMsg("Regional Harus Dipilih")
        return false
      } else if (!this.gpon.default_user_nms) {
        if (this.username == null || this.username === '') {
          this.$refs.dlgMsg.doOpenMsg("Username Gpon Harus Diisi")
          return false
        } else if (this.password == null || this.password === '') {
          this.$refs.dlgMsg.doOpenMsg("Password Gpon Harus Diisi")
          return false
        }
      }
      return true
    }
  },
}
</script>

<style scoped>

</style>